#fire-http
[![Build Status](https://secure.travis-ci.org/firejs/fire-http.png)](http://travis-ci.org/firejs/fire-http)

Http expressions for [fire.js](https://github.com/firejs/fire)
***

## Installing

### using NPM

    npm install fire-http

## Expressions

* @Http
* @Http.Headers.Authorization

## Usage

`Sending a GET`

    "@Http(GET)": {
		"uri": "http://127.0.0.1:3600/"
	}

or with dynamic method:

    "@Http": {
		"method": "GET",
		"uri": "http://127.0.0.1:3600/"
	}

`Sending a POST with Body`

    "@Http(POST)": {
		uri: "http://127.0.0.1:3603/",
		body: "Content of the Body"
    }

`Headers`

    "@Http(GET)": {
		uri: "http://127.0.0.1:3604/",
		headers: {
			"CustomHeader": "Stuff"
		}
    }

`Basic Authorization`

	"@Http(GET)": {
		uri: "http://127.0.0.1:3604/",
		headers: {
			"Authorization": {
				"@Http.Headers.Authorization(Basic)": {
					"user": "Chuck",
					"password": "SuperChuck"
				}
			}
		}
    }
    

or 

    "@Http(GET)": {
		uri: "http://127.0.0.1:3604/",
		headers: {
			"Authorization": {
				"@Http.Headers.Authorization": {
					"scheme": "Basic",
					"user": "Chuck",
					"password": "SuperChuck"
				}
			}
		}
	}

## Cloning the Repository

    git clone git://github.com/firejs/fire-http.git

### Tests

    make run-tests

### Contributors

* Johan (author). Email: *johan@firebase.co*

## MIT License

Copyright (c) 2011 Firebase.co - http://www.firebase.co

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.