var vows = require('vows')
var assert = require('assert')
var spawn = require('child_process').spawn

function copyProcessEnv() {
	var e = {}
	Object.keys(process.env).forEach(function(k) {
		e[k] = process.env[k]
	});
	return e
}

function runTestServer(fixtureName, doRequestCallback, execOptions) {
	var testContext = this	
	var testMainScript = "test/fixtures/" + fixtureName + ".js"
	testContext.testErr = null
	testContext.testRes = null
	testContext.stderr = ""
	testContext.stdout = ""
	testContext.exitCode = null
	var shouldPrintToConsole = !execOptions || !execOptions.DONT_PRINT_TO_CONSOLE
	
		var fireJsProcess =  null
		var cancelTest = false
		var serverError = null
		var processResult = {}
		
		if(execOptions && execOptions.env) {
			fireJsProcess = spawn('node', [testMainScript], execOptions)
		} else {
			fireJsProcess = spawn('node', [testMainScript])
		}
		fireJsProcess.stdout.setEncoding('utf8');
		fireJsProcess.stdout.on('data', function(data) {
			//console.log("stdout data", data)
			testContext.stdout += data
			if(data.indexOf('running') != -1) {
				//setTimeout(function() {
					// execute the test
					doRequestCallback(function(err, res) {
						testContext.testErr = err
						testContext.testRes = res
						fireJsProcess.kill()
					})
				//}, 3000)
				
			}
		})
		fireJsProcess.stderr.setEncoding('utf8');
		fireJsProcess.stderr.on('data', function(data) {
			//console.log("stderr data", data)
			testContext.stderr += data
		})
		fireJsProcess.on("exit", function(code, signal) {
			testContext.exitCode = code
			testContext.callback(null, testContext)
		})
	/*
			if(!cancelTest) {
				doRequestCallback(function(err, res) {
					testContext.testErr = err
					testContext.testRes = res
					fireJsProcess.kill()
					
				})
			} else {
				testContext.callback(">>> Something went wrong initializing the server: " + serverError, null)
			}*/
}

module.exports.runTestServer = runTestServer
module.exports.copyProcessEnv = copyProcessEnv